// RockFalls Raceway 1/4 mile drag race script. 
//Created by CuriousMike, based on original script from Xploder98.
#include "base.as";
#include "races.as";

racesManager races();


// GENERAL SECTION 0 START
int race_0_1_4_mile_drag_ID;
// GENERAL SECTION 0 END
float speed18_mph = 0;
float speed18_kph = 0;
float speedfin_mph = 0;
float speedfin_kph = 0;


// GENERAL SECTION GENERAL START

// GENERAL SECTION GENERAL END


void main()
{
 races.setCallback('RaceStart', on_RaceStart_event);
 races.setCallback("RaceFinish", on_raceFinish);
 races.setCallback("Checkpoint", on_checkpointPassed);
 races.showCheckPointInfoWhenNotInRace = false;

    // MAIN SECTION 0 START
  race_0_1_4_mile_drag_ID = races.addNewEmptyRace();
 races.setRaceName(race_0_1_4_mile_drag_ID, "1/4 mile drag");
 races.setLaps(race_0_1_4_mile_drag_ID, races.LAPS_NoLaps);
   array<array<double>> race_0_coords = {
      //starting line
       {83.568, 2.14, 95.989, 0.0, 82.8, 0.0},
	   //60ft
       {101.633,    2.140,   98.747,    0.0,   82.8,    0.0},
	   //330ft
       {183.044,    2.140,  110.503,    0.0,   82.8,    0.0},
	   //1/8th speed light (66ft)
       {260.853,    2.140,  121.776,    0.0,   82.8,    0.0},
	   //660ft
       {280.793,    2.140,  124.617,    0.0,   82.8,    0.0},
	   //1000ft
       {385.212,    2.140,  139.742,    0.0,   82.8,    0.0},
	   // finish speed light (66ft)
       {461.948,    2.140,  150.825,    0.0,   82.8,    0.0},
	   //finish line
       {481.876,    2.140,  153.626,    0.0,   82.8,    0.0}
   };
   races.addCheckpoint(race_0_1_4_mile_drag_ID, 0, "empty-checkpoint-RF", race_0_coords[0]);
   races.addCheckpoint(race_0_1_4_mile_drag_ID, 1, "empty-checkpoint-RF", race_0_coords[1]);
   races.addCheckpoint(race_0_1_4_mile_drag_ID, 2, "empty-checkpoint-RF-fin", race_0_coords[2]);
   races.addCheckpoint(race_0_1_4_mile_drag_ID, 3, "empty-checkpoint-RF-fin", race_0_coords[3]);
   races.addCheckpoint(race_0_1_4_mile_drag_ID, 4, "empty-checkpoint-RF-fin", race_0_coords[4]);
   races.addCheckpoint(race_0_1_4_mile_drag_ID, 5, "empty-checkpoint-RF-fin", race_0_coords[5]);
   races.addCheckpoint(race_0_1_4_mile_drag_ID, 6, "empty-checkpoint-RF-fin", race_0_coords[6]);
   races.addCheckpoint(race_0_1_4_mile_drag_ID, 7, "empty-checkpoint-RF-fin", race_0_coords[7]);
   races.setVersion(race_0_1_4_mile_drag_ID, "RockFalls-1.0");
   races.setPenaltyTime(race_0_1_4_mile_drag_ID, 10);
   races.finalize(race_0_1_4_mile_drag_ID);
   // MAIN SECTION 0 END

//    races.addCancelPoint(-1, "empty-checkpoint-RF-mid", vector3(482.041,    2.523,  153.733f), vector3(0.0,  171.8,    0.0f));
		// add a cancel point for all races (we can do this for all races by setting the race ID to -1)
   double[][] cancelpoint = {{482.041,    2.523,  153.733,    0.0,  171.8,    0.0}};
   races.addCancelPoint(-1, "empty-checkpoint-RF-mid", cancelpoint[0], on_cancelPoint);
}

void on_RaceStart_event(dictionary@ event)
{
 int raceID;
 event.get('raceID', raceID);


   // RACESTART SECTION 0 START
  if( raceID == race_0_1_4_mile_drag_ID )
  {
      races.obligatedFinish = false;
      races.showTimeDiff = true;
      races.showBestLap = true;
      races.showBestRace = true;
      races.submitScore = true;
      races.silentMode = false;
      races.restartRaceOnStart = true;
  }
  // RACESTART SECTION 0 END
}

void eventCallback(int eventnum, int value)
{
 races.eventCallback(eventnum, value);
}

// the event callback for our cancelpoint
void on_cancelPoint(dictionary@ info)
{
	game.message("Disqualified for lane boundary crossing.", "cancel.png", 50000, true); 
}

void on_checkpointPassed(dictionary@ info)
{	
	if(races.lastCheckpoint == 3)
	{
	   BeamClass @b = game.getCurrentTruck();
       speed18_mph = b.getSpeed() * 2.237;
	   speed18_kph = b.getSpeed() * 3.6;
	}	
	if(races.lastCheckpoint == 6)
	{
	   BeamClass @b = game.getCurrentTruck();
       speedfin_mph = b.getSpeed() * 2.237;
	   speedfin_kph = b.getSpeed() * 3.6;
	}	
}


// The event callback for finishing a race
void on_raceFinish(dictionary@ info)
{
    // Get the race ID
    int raceID;
    info.get("raceID", raceID);
    
    // get the lap time (in seconds)
    float lapTime = game.getTime() - races.lapStartTime;
	//Get times
	float sixtyTime = races.raceList[raceID].lastTimeTillPoint[1];
	float halfwayTime = races.raceList[raceID].lastTimeTillPoint[2];
	float sixsixtyTime = races.raceList[raceID].lastTimeTillPoint[3];
	float thousandTime = races.raceList[raceID].lastTimeTillPoint[4];
	
	//Display "time slip" at the end of a run

    game.message("RockFalls Raceway Time Slip", "chart_bar.png", 200000, true);
	game.message("60ft: " + races.formatTime(sixtyTime), "chart_bar.png", 200000, true);
	game.message("330ft: " + races.formatTime(halfwayTime), "chart_bar.png", 200000, true);
	game.message("1/8th: " + races.formatTime(sixsixtyTime) + " @ " + speed18_mph + " mph" + " (" + speed18_kph + " kph)","chart_bar.png", 200000, true);
	game.message("1000ft: " + races.formatTime(thousandTime), "chart_bar.png", 200000, true);
	game.message("Finishing Time: " + races.formatTime(lapTime) + " @ " + speedfin_mph + " mph" + " (" + speedfin_kph + " kph)","chart_bar.png", 200000, true);
}
  